<!DOCTYPE html>
<html>
	<head>
		<meta
			charset="utf-8"
			name="viewport"
			content="width=device-width, initial-scale=1"
		/>
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<link
			rel="stylesheet"
			href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
		<!-- Import DataTable Library -->

		<link
			rel="stylesheet"
			href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css"
		/>
		<script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
	</head>

  <body>
    <div class="container">
      <div class="text-center mt-0 mb-0">
        <h2>F200 - LỊCH SỬ HỌC TẬP</h2>
      </div>
      <div class="jumbotron container">
        <div class="row"><h3>Thông tin Student</h3></div>
        <div class="row form-group d-flex mt-4">
          <div class="col-sm-5">
            <div class="row">
              <div class="col-sm-4">
                <label for="student">Student</label>
              </div>
              <div class="col-sm-8">
                <select id="gStudentSelect" class="form-control"></select>
              </div>
            </div>
          </div>
          <div class="col-sm-5">
            <div class="row">
              <div class="col-sm-4">
                <label for="subject">Toán cấp 1</label>
              </div>
              <div class="col-sm-8">
                <select id="gsubjectSelect" class="form-control"></select>
              </div>
            </div>
          </div>
          <div class="col-sm-2">
            <button id="btn-filter-student" class="btn btn-info">Lọc dữ liệu</button>
          </div>
        </div>
    </div>
    
    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="user-table">
        <thead>
          <tr>
            <th>STT</th>
            <th>Student</th>
            <th>Môn học</th>
            <th>Điểm</th>
            <th>Ngày thi</th>
          </tr>
        </thead>
      </table>
    </div>

  </body>
	<script>
		'use strict';
		/* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
		 */
		var gStudents = [
			{
				id: 2, // tự tăng
				studentCode: '1356783',
				firstname: ' Van',
				lastname: 'a',
				age: 18,
				email: 'quan@gmail.com',
				studyYear: 2015,
			},
			{
				id: 3, // tự tăng
				studentCode: '1356743',
				firstname: 'Ngo ',
				lastname: 'b',
				age: 18,
				email: 'quan@gmail.com',
				studyYear: 2015,
			},
			{
				id: 4, // tự tăng
				studentCode: '1355783',
				firstname: ' Van',
				lastname: 'c',
				age: 23,
				email: 'quan@gmail.com',
				studyYear: 2015,
			},
			{
				id: 5, // tự tăng
				studentCode: '1336783',
				firstname: 'Ngo Van',
				lastname: 'Quan',
				age: 18,
				email: 'quan@gmail.com',
				studyYear: 2015,
			},
			{
				id: 6, // tự tăng
				studentCode: '1396783',
				firstname: 'z Van',
				lastname: 'm',
				age: 18,
				email: 'quan@gmail.com',
				studyYear: 2015,
			},
		];

		var gSubjects = [
			{
				id: 5, // tự tăng
				subjectCode: 'MATH101',
				subjectName: 'Toán cao cấp 2',
			},
			{
				id: 6, // tự tăng
				subjectCode: 'MATH102',
				subjectName: 'Toán cao cấp 3',
			},
			{
				id: 7, // tự tăng
				subjectCode: 'MATH103',
				subjectName: 'Toán cao cấp 4',
			},
			{
				id: 8, // tự tăng
				subjectCode: 'MATH104',
				subjectName: 'Toán cao cấp 5',
			},
			{
				id: 9, // tự tăng
				subjectCode: 'MATH105',
				subjectName: 'Toán cao cấp 6',
			},
			// điền thêm 04 môn học nữa
		];

		var gGrades = [
			{
				id: 2, // tự tăng
				studentId: 6,
				subjectId: 6,
				grade: 2,
				examDate: '13/04/2021',
			},
			{
				id: 3, // tự tăng
				studentId: 4,
				subjectId: 5,
				grade: 3,
				examDate: '13/04/2021',
			},
			{
				id: 4, // tự tăng
				studentId: 2,
				subjectId: 5,
				grade: 1,
				examDate: '13/04/2021',
			},
			{
				id: 5, // tự tăng
				studentId: 6,
				subjectId: 7,
				grade: 9,
				examDate: '13/04/2021',
			},
			{
				id: 6, // tự tăng
				studentId: 2,
				subjectId: 8,
				grade: 6,
				examDate: '13/04/2021',
			},
			{
				id: 7, // tự tăng
				studentId: 2,
				subjectId: 9,
				grade: 4,
				examDate: '18/04/2021',
			},
			{
				id: 8, // tự tăng
				studentId: 4,
				subjectId: 6,
				grade: 7,
				examDate: '17/04/2021',
			},
			{
				id: 9, // tự tăng
				studentId: 2,
				subjectId: 8,
				grade: 6,
				examDate: '16/04/2021',
			},
			{
				id: 10, // tự tăng
				studentId: 4,
				subjectId: 6,
				grade: 4,
				examDate: '14/04/2021',
			},

			// điền thêm 9 kết quả thi nữa
		];
    var gStt=1;
            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#btn-filter-student").on("click",function() {
              onBtnFilterClick()
            });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
      "use strict";
      $('#user-table').DataTable({
        data: gGrades,
        columns: [
            { data: 'id' },
            { data: 'studentId' },
            { data: 'subjectId' },
            { data: 'grade' },
            { data: 'examDate' },
        ],
        columnDefs: [
        { targets: 0,
          
         render: function(data) {
          return gStt++;
         }},
         { targets: 1,
          
          render: studentIdToStudent
          },
          { targets: 2,
          
          render: subjectIdToSubject
          },
      
          ]
          });

          loadStudentToSelect(gStudents);
          loadSubjectToSelect(gSubjects);
        } 


        function onBtnFilterClick(){
            var vFilterObj = {
              studentId: 0,
              subjectId: 0
            }

            getDataFilterObj(vFilterObj);
            var vFilter = filterData(vFilterObj);
            console.log(vFilter)
            displayToTable(vFilter)
          }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function studentIdToStudent(paramData){
          var vStudent = "";
          for(var bI = 0; bI < gStudents.length;bI++){
            if(paramData == gStudents[bI].id){
              vStudent =  (gStudents[bI].firstname+ " " + gStudents[bI].lastname);
            }
          }

          return vStudent;
        }
        function subjectIdToSubject(paramData){
          var vSubject = "";
          for(var bI = 0; bI < gSubjects.length;bI++){
            if(paramData == gSubjects[bI].id){
              vSubject = (gSubjects[bI].subjectName);
            }
          }
           return vSubject
        }

        function loadStudentToSelect(paramData) {
      $("#gStudentSelect").append($("<option>", {
        value: 0,
        text: "--chon Student--"
      }))

      for(var bI = 0 ; bI < paramData.length;bI++){
        $("#gStudentSelect").append($("<option>", {
        value: paramData[bI].id,
        text: paramData[bI].firstname + " " + paramData[bI].lastname
      }))
      }
    }

    function loadSubjectToSelect(paramData) {
      $("#gsubjectSelect").append($("<option>", {
        value: 0,
        text: "--chon Subject--"
      }))

      for(var bI = 0 ; bI < paramData.length;bI++){
        $("#gsubjectSelect").append($("<option>", {
        value: paramData[bI].id,
        text: paramData[bI].subjectName
      }))
      }
    }

    function getDataFilterObj(paramData){
        paramData.studentId = $("#gStudentSelect").val();
        paramData.subjectId = $("#gsubjectSelect").val();
      }


      function filterData(paramData){
            var vResult = [];
            vResult = gGrades.filter(function(item) {
              return (item.studentId == paramData.studentId && item.subjectId == paramData.subjectId)
            });
            return vResult;
          }

          
			function displayToTable(paramData) {
				gStt = 1;
				var vTable = $('#user-table').DataTable();
				vTable.clear();
				vTable.rows.add(paramData);
				vTable.draw();
			}
	</script>
</html>
